;PureBasic 4.61 (x64)
;VCVTPH2PS  Convert Half-Precision Floating-Point To Single-Precision Floating Point
;VCVTPS2PH  Convert Single-Precision Floating-Point To Half-Precision Floating Point  

Global A.q = 0          ;64-Bit-Memory, Ziel fr max. 4 Half-Precision Floating Points a 16Bit
Global B.f = 12.345     ;zu konvertierender Wert, Single-Precision
Global C.f = 0.0
No = 0
Ausgabe$ = "Ja"         ;ich bin immer Optimist! 

!mov eax,1h
!cpuid
!test ecx,20000000h     ;F16C, Bit29 von ECX
!jnz l_f16c             ;Bit 29 gesetzt -> F16C verfgbar 
No = 1                  ;F16C nicht verfgbar
Ausgabe$ = "Nein"
F16C:
MessageRequester("Test auf F16C", "CPUID sagt : " + Ausgabe$)

If No = 1
  Abfrage = MessageRequester("Testprogramm F16C", "Testprogramm dennoch ausfhren ? (Kann zu Programm-Absturz fhren !)", #PB_MessageRequester_YesNo)
EndIf
If Abfrage = #PB_MessageRequester_No
  End
EndIf

MessageRequester("Testprogramm F16C", "Es wird 12.345 (Single-Precision) in Half-Precision Floating Point und wieder zurck konvertiert (MXCSR.RC for rounding)")

!movss xmm2,dword[v_B]       ;fr diesen Test wird nur ein Float-Wert konvertiert      
!VCVTPS2PH qword[v_A],xmm2,4 ;s.o., 4 = Use MXCSR.RC for rounding 
!VCVTPH2PS xmm3,qword[v_A]
!movss dword[v_C],xmm3       ;Ergebnis der Rck-Konvertierung

MessageRequester("Testprogramm F16C", "Der Ausgangswert war : " + StrF(B, 6) + #LFCR$ + "Wert der Rck-Konvertierung : " + StrF(C, 6))
; IDE Options = PureBasic 4.61 (Windows - x64)
; CursorPosition = 19
; EnableXP
; DisableDebugger